#ifndef TIMEWALKALGORITHM_H
#define TIMEWALKALGORITHM_H

#include "AnalysisAlgorithm.h"

namespace SctAnalysis {
    /**
       Algorithm for TimeWalk Test.
    */
class TimeWalkAlgorithm : public AnalysisAlgorithm {
public:
    /**
       over-ride
     */
    virtual void canAddFitScanResult(const string& name) throw(Sct::LogicError, Sct::IoError);
    /**
     * over-ride
     */
    virtual boost::shared_ptr<AnalysisAlgorithm> clone(const TestData& testData, const string& moduleName) const throw();
    /** 
	constructor 
     */
    TimeWalkAlgorithm(const TestData& testData, const string& moduleName) throw() : AnalysisAlgorithm(testData, moduleName) {}
    /** 
	destructor 
     */
    virtual ~TimeWalkAlgorithm() throw() {}
    
private:
    TimeWalkAlgorithm() {}
    static bool inMap;
};
}

#endif //TIMEWALKALGORITHM_H
