#include "Sct/Version.h"
#include <iostream>
#include <cstring>
using namespace Sct;
using namespace std;


void longVersion() {
    cout << "VersionString:" << VersionString << endl;
    cout << "MajorVersion: " << MajorVersion << " Minor Version: " << MinorVersion << " Modifier: " << VersionModifier << endl;
    cout << "Version: " << Version << endl;
    cout << "BuildSystem: " << BuildSystem << endl;
    cout << "BuildHost: " << BuildHost << endl;
    cout << "BuildDate: " << BuildDate << endl;
    cout << "RodDaq Version: " << RodDaqVersion << endl;
    cout << "CmtConfig: " << CmtConfig << endl;
    cout << "Dataflow Version: " << DataFlowVersion << endl;
    cout << "OnlineVersion : " << OnlineVersion << endl;
    cout << "RootVersion: " << RootVersion << endl;
    cout << "GccVersion: " << GccVersion << endl;    
}

void shortVersion() {
    cout << Version << VersionModifier << endl;
}

void helpMessage() {
    cout << "Prints out version information about the SctRodDaq system." << endl << endl;
    cout << "Usage: SctRodDaqVersion <options>" << endl;
    cout << "Possible options are: " << endl;
    cout << "\t-h, --help\t\tPrint this help message" << endl;
    cout << "\t-l, --long\t\tPrint out all version information" << endl;
    cout << "\t-s, --short\t\tPrint out short version information" << endl;
    cout << endl << "If no option is given, the default is -s" << endl;
}

void handleShortArg(char arg) {
    switch (arg) {
    case 'h':
	helpMessage();
	break;
    case 'l':
	longVersion();
	break;
    case 's':
	shortVersion();
	break;
    default:
	cout << "Argument -" << arg << " not recognized" << endl;
    }
}

void handleLongArg(const char* arg) {
    if (strcmp(arg, "--help") == 0) return handleShortArg('h');
    if (strcmp(arg, "--long") == 0) return handleShortArg('l');
    if (strcmp(arg, "--short") == 0) return handleShortArg('s');
    cout << "Argument " << arg << " not recognized" << endl;
    helpMessage();
}

void handleArg(const char* arg) {
    if (arg[0] != '-') {
	cout << "Argument " << arg << " not recognized" << endl;
	helpMessage();
	return;
    }
    if (strlen(arg) == 2) handleShortArg(arg[1]);
    else handleLongArg(arg);
}

int main(int argc, char** argv) {
    //Handle args
    switch (argc) {
    case 1:
	shortVersion();
	break;
    case 2:
	handleArg(argv[1]);
	break;
    default:
	helpMessage();
    }
    return 0;
}
