#ifndef SCT_IONAME_H
#define SCT_IONAME_H

#include "LogicErrors.h"

namespace Sct {


class IOName {
public:
    IOName(const string& nameIO) throw(InvalidArgumentError);
    IOName(const string& uniqueID, const string& className) throw();
    virtual ~IOName() throw();
    
    string getIOName() const throw();
    string getUniqueID() const throw();
    
protected:
    /**
      Must set uniqueID from nameIO.
      @throw InvalidArgument if this isn't possible.
      */
    virtual void parse() throw(InvalidArgumentError) = 0;
    
    /**
      Must set nameIO from uniqueID and className.
      */
    virtual void construct() throw() = 0;
    
    string uniqueID;
    string className;
    string nameIO;
};

}

#endif //SCT_IONAME_H
