#ifndef SCT_TIMER_H
#define SCT_TIMER_H

#include <sys/time.h>

namespace Sct {
 
    /**
      Get the current time in seconds with millisecond accuracy.
      Useful for timing short operations.  Only utilizes first few
      numbers of seconds.
      */
    inline double timer() {
	timeval tv;
	gettimeofday(&tv, 0);
	return tv.tv_sec%1000 + tv.tv_usec/1000000.;
    }
    
}

#endif //SCT_TIMER_H
