#include "ConfigurationVariableStreamer.h"
#include "../ConfigurationVariable.h"


namespace SctData {
namespace IO {
    
bool ConfigurationVariableStreamer::inMap = IOManager::addToMap("SctData::ConfigurationVariable", std::auto_ptr<Streamer>(new ConfigurationVariableStreamer()));    
ConfigurationVariableStreamer::ConfigurationVariableStreamer() throw() {}

void ConfigurationVariableStreamer::write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
    const ConfigurationVariable& var = dynamic_cast<const ConfigurationVariable&>(ob);
    out << ConfigurationVariableIOHelper::getTypeRep(var);
}

shared_ptr<Streamable> ConfigurationVariableStreamer::read(IStream& in, const IOManager& manager) const throw(LogicError, IoError) {
    unsigned short rep = 0;
    in >> rep;
    return ConfigurationVariableIOHelper::getFromTypeRep(rep);
}

void ConfigurationVariableStreamer::read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
    ///@todo throw Sct::LogicError("Unsupported operation in ConfigurationVariableIS", MRS_ERROR, "libSctDataIS");
}

}
}
