#ifndef SCTDATA_IO_FULLBYPASSTESTRESULTSTREAMER_H
#define SCTDATA_IO_FULLBYPASSTESTRESULTSTREAMER_H

#include "TestResultStreamer.h"
#include "../FullBypassTestResult.h"
#include "Sct/LogicErrors.h"
#include "Sct/IoExceptions.h"

namespace SctData {
namespace IO {

/**
 * This class allows publishing and refreshing of FullBypassTestResult objects
 */
class FullBypassTestResultStreamer : public TestResultStreamer {
public:
    //Streamer overrides
    virtual void write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);
    virtual shared_ptr<Streamable> read(IStream& in, const IOManager& manager) const throw(LogicError, IoError);
    virtual void read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);   
    void writeChipResult(OStream& out, const FullBypassTestResult::ChipFBResult&, const IOManager& manager) const throw(LogicError, IoError) ;
    void readChipResult(IStream& in, FullBypassTestResult::ChipFBResult&, const IOManager& manager) const throw(LogicError, IoError) ;
private:
    FullBypassTestResultStreamer() throw();
    static bool inMap;
};
}
}

#endif // #ifndef SCTDATA_IO_FULLBYPASSTESTRESULTSTREAMER_H
