#ifndef SCTDATA_IO_MODULEDEFECTLISTIS_H
#define SCTDATA_IO_MODULEDEFECTLISTIS_H

#include "Sct/Exception.h"
#include "Sct/Streamable.h"
#include "Sct/Streamer.h"
#include "../ModuleDefectIOHelper.h"

using namespace Sct;

namespace SctData {
namespace IO {

/**
This class is a Streamer for reading/writing ModuleDefectList
*/
class ModuleDefectListStreamer : public virtual Streamer {
public:
    //Streamer overrides
    virtual void write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);
    virtual shared_ptr<Streamable> read(IStream& in, const IOManager& manager) const throw(LogicError, IoError);
    virtual void read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);   

private:
    ModuleDefectIOHelper helper;		///< The IOHelper
    ModuleDefectListStreamer() throw();					///< Constructor is private
    static bool inMap;					///< The static dummy variable for the ISManager map
};

}
}
#endif //#ifndef SCTDATA_IO_MODULEDEFECTLISTIS_H
