#include "PipelineTestResultStreamer.h"
#include "../PipelineTestResult.h"

using namespace Sct;

namespace SctData {
namespace IO {

PipelineTestResultStreamer::PipelineTestResultStreamer() throw() {}

bool PipelineTestResultStreamer::inMap = IOManager::addToMap("SctData::PipelineTestResult", auto_ptr<Streamer>(new PipelineTestResultStreamer()));

shared_ptr<Streamable> PipelineTestResultStreamer::read(IStream& in, const IOManager& manager) const throw(LogicError, IoError){
    shared_ptr<Streamable> ad (new PipelineTestResult());
    read(in, *ad, manager);
    return ad;
}

void PipelineTestResultStreamer::write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
    //Let superclass do its work
    TestResultStreamer::write(out, ob, manager);
}

void PipelineTestResultStreamer::read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
    TestResultStreamer::read(in, ob, manager);
}

} 
}
