#ifndef SCTDATA_IO_RESPONSECURVESTREAMER_H
#define SCTDATA_IO_RESPONSECURVESTREAMER_H

#include "Sct/Streamable.h"
#include "Sct/Streamer.h"
#include "Sct/LogicErrors.h"
#include "Sct/IoExceptions.h"

using namespace Sct;

namespace SctData {
namespace IO {
    
class ResponseCurveStreamer : public virtual Streamer {
public:
    //Streamer overrides
    virtual void write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);
    virtual shared_ptr<Streamable> read(IStream& in, const IOManager& manager) const throw(LogicError, IoError);
    virtual void read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);   
    
private:
    ResponseCurveStreamer() throw();              ///< Constructor is private
    static bool inMap;                      ///< The static dummy variable for the IOManager map
};
} 
}
#endif //#ifndef SCTDATA_IO_RESPONSECURVESTREAMER_H
