#include "ScanHeaderStreamer.h"
#include "../ScanHeader.h"
#include "../ConfigurationVariable.h"
#include "../mVThresholdVariable.h"

#include <string>

using std::string;
using namespace Sct;

namespace SctData {
namespace IO {

ScanHeaderStreamer::ScanHeaderStreamer() throw() {}

bool ScanHeaderStreamer::inMap = IOManager::addToMap("SctData::ScanHeader", auto_ptr<Streamer>(new ScanHeaderStreamer()));

shared_ptr<Streamable> ScanHeaderStreamer::read(IStream& in, const IOManager& manager) const throw(LogicError, IoError) {
    shared_ptr<Streamable> ad (new ScanHeader(0, 0, "", mVThresholdVariable::instance()));
    read(in, *ad, manager);
    return ad;
}

void ScanHeaderStreamer::write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
    //Downcast should always work!
    const ScanHeader& header = dynamic_cast<const ScanHeader&>(ob);

    out << header.getRunNumber() << header.getScanNumber() << header.getModuleName();
    manager.writeImpl(out, header.getVariable(), false);
}

void ScanHeaderStreamer::read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
    //Downcast should always work!
    ScanHeader& header = dynamic_cast<ScanHeader&>(ob);

    headerHelper.set(header);
    // cout << "ScanHeaderIS refresh" << endl;
    in >> headerHelper.getRunNumber();
    in >> headerHelper.getScanNumber();
    in >> headerHelper.getModuleName();
    shared_ptr<Streamable> ob2 = manager.readImpl(in, "SctData::ConfigurationVariable");
    headerHelper.getVariable() = boost::dynamic_pointer_cast<ConfigurationVariable>(ob2).get();	///Should always succeed!

    // cout << "Done" << endl;
}

}
}
