#ifndef SCTDATA_IO_SCANRESULTSTREAMER_H
#define SCTDATA_IO_SCANRESULTSTREAMER_H

#include "Sct/Streamer.h"
#include "../ScanResultIOHelper.h"
#include "Sct/LogicErrors.h"
#include "Sct/IoExceptions.h"

class ISostream;
class ISistream;
class Sct::Streamable;

using namespace std;
using namespace Sct;

namespace SctData {
namespace IO {


/**
This abstract class is an ISSerializer for reading/writing ScanResults to/from IS.
Doesn't implement createObject.
*/
class ScanResultStreamer : public virtual Streamer {
protected:
    ScanResultStreamer() throw();			///< Constructor must be protected for sub-classes

    //Streamer overrides
    virtual void write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);
    virtual void read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);   

private:
    ScanResultIOHelper helper;				///< The IOHelper
};
}
}
#endif //#ifndef SCTDATA_IO_SCANRESULTSTREAMER_H
