#ifndef MODULEDEFECTIOHELPER_H
#define MODULEDEFECTIOHELPER_H

#include "ModuleDefect.h"
#include "Sct/LogicErrors.h"

namespace SctData {
class ModuleDefectIOHelper {
public:	
	int getRepresentation(const ModuleDefect& defect) const throw();
        const ModuleDefect& getFromRep(int id) const throw(Sct::LogicError);
};

//Inlines
inline int ModuleDefectIOHelper::getRepresentation(const ModuleDefect& defect) const throw() {
	return defect.id;
}

inline const ModuleDefect& ModuleDefectIOHelper::getFromRep(int id) const throw(Sct::LogicError) {
    if (ModuleDefect::defectMap.find(id)==ModuleDefect::defectMap.end() ){
	ostringstream os; os<<"ModuleDefectIOHelper::getFromRep : no representation "<<id;
	throw Sct::InvariantViolatedError(os.str(), __FILE__, __LINE__);
    }
    return *ModuleDefect::defectMap[id];
}

}
#endif //#ifndef MODULEDEFECTIOHELPER_H
