#include "SctApiTest.hh"
#include "servernames.h"

#include "ipc/object.h"

#include <iostream>

using namespace std;

int main(int argv, char** argc) {
	SctApiTestStatus status;

	IPCPartition p(Partition_Name);
// retrieve pointer to published object
	IPCObjectVar<SctApiTest_T_sctapi> sctapi = p.lookup(API_Server_Name, API_Object_Name, SctApiTest_T_sctapi::ILUClassRecord);
	if (sctapi ==0 ) {
		cout << "Error" <<endl;
		return -1;
	}
	status.returnCode = 0;
	char* text = sctapi->ping(&status,"theteststring");
	cout << text <<endl;
// initialise
        sctapi->initialise(&status);
// configure
        if(sctapi->configure(&status,"configfile.xtml")!=0 || status.returnCode!=0) cout << "Configuration failed" << endl;
        cout << "Configuration set to: " << sctapi->getConfigName(&status) << endl;

//        sctapi->publishRawData(&status);
//        sctapi->publishRootData(&status,"2d");
// publish response curve scan

        sctapi->doStrobeDelayScan(&status);
        sctapi->doThreePointGainScan(&status);
        sctapi->doTrimScan(&status);
        sctapi->doResponseCurveScan(&status);
        sctapi->doNoiseScan(&status);

}
