#include "../VmeInterface/DummyVmeInterface.h"
#ifndef USE_DUMMY_VME
#include "../VmeInterface/RCCVmeInterface.h"
#endif

#include "VmeDecode.h"

using namespace SctPixelRod;
using namespace std;

namespace SctApi {
  namespace Utility {
    void decodeVme(VmeException &e) {
      cout << "VmeException Code: " << e.getErrorCode() << " Class: ";

      switch(e.getErrorClass()) {
      case VmeException::OK: cout << "OK\n"; break;
      case VmeException::INIT_ERROR: cout << "Init error\n"; break;
      case VmeException::BUS_ERROR: cout << "Bus error\n"; break;
      case VmeException::MAP_ERROR: cout << "Map error\n"; break;
      case VmeException::DMA_ERROR: cout << "Dma error\n"; break;
      default: cout << "Unknown error class\n"; break;
      }

      VmePort *p = e.getPort();

      if(p) {
        cout << "Port: code: " << p->getLastErrcode() << " " 
             << p->getErrorMessage(p->getLastErrcode()) << endl;
      } else {
        std::cout << "No port available\n";
      }
    }
  }
}
