#include <iostream>                 // XXX This is for debug only!

#include "RodCrate/RodModule.h"
#include "RodCrate/BocCard.h"
#include "RodCrate/TimModule.h"              // For TimMaskFrequency

#include "crate.h"

namespace SctApi {
#if USE_THREADS
  void Crate::pollingLoop() {
    std::cout << "Starting Polling loop\n";

    // Only one primitive list at a time
    // so only one time out 
//     bool timedout = false;
//     time_t start_time = time(0);

// #warning "This should be set for each primitive"
//     int timeout = 5;

    while(1) {
      int rods = 0;

#warning "Need to handle all queue!"

      // For each rod:
      for(RodMap::iterator i=rodMap.begin();i!=rodMap.end();i++){
        SctPixelRod::RodModule &rod = *(i->second.second);
        RodStatus &status = *(i->second.first);
        //   Get locks
        {
          boost::mutex::scoped_lock statLock(status.mutex);
          SctPixelRod::PrimState oldPrimState = rod.getPrimState();
#warning "This should be initialised to something..."
          SctPixelRod::PrimState newPState;

          try {
            boost::mutex::scoped_lock lock(vmeMutex);
            //   PrimHandler
            newPState = rod.primHandler();
          } catch (SctPixelRod::BaseException &ex) {
            std::cerr << "Exception in polling loop: " << ex << std::endl;
#warning "Should do something here!"
          } catch (...) {
            std::cerr << "Unknown exception in polling loop\n";
#warning "Should do something here!"
          } // Keep VME lock for duration of try

//             std::cout << "POLL: PrimHandler state " << newPState << "\n" ;
//             std::cout << "POLL: Mystate " << status.currState << "\n" ;
//             std::cout << "POLL: Queue suze " << status.listQueue.size() << "\n" ;

          if((newPState == SctPixelRod::PRIM_IDLE || newPState == SctPixelRod::PRIM_WAITING) 
             && status.currState == MYPRIM_LOADED) {
            if(status.listQueue.size() > 0) {
              //                 std::cout << "Polling Thread::  Send prim list\n" ;

              shared_ptr<PrimListWrapper> nextPrimList = status.listQueue.front();
              status.listQueue.pop_front();
              rod.sendPrimList(nextPrimList->list.get());   // Pass in auto_ptr (only used briefly)
            } else {
              //                 std::cout << "Polling Thread::  No prim lists\n" ;
            }
          }

          if(oldPrimState != newPState) {
            //               std::cout << "New primHandler state " << newPState << "\n" ;

            // Just entered new state...
            switch(newPState) {
            case SctPixelRod::PRIM_LOADED:
            case SctPixelRod::PRIM_EXECUTING:
              status.currState = MYPRIM_EXECUTING;
//                 std::cout << "STATE: Changing state to executing\n";
              break;
            case SctPixelRod::PRIM_IDLE:
            case SctPixelRod::PRIM_WAITING:
              status.currState = MYPRIM_COMPLETE;
//                 std::cout << "STATE: Change state to COMPLETE\n";
              break;
            case SctPixelRod::PRIM_PAUSED:
              break;
            }
          }

          try {
            boost::mutex::scoped_lock lock(vmeMutex);
            //   TextHandler
            SctPixelRod::TextBuffState newTState = rod.textHandler();

            while (newTState == SctPixelRod::TEXT_RQ_SET) {
              doTextBuffer(rod);

              newTState = rod.textHandler();
            }
          } catch (SctPixelRod::BaseException &ex) {
            std::cerr << "Exception in polling loop: " << ex << std::endl;
#warning "Should do something here!"
          } catch (...) {
            std::cerr << "Unknown exception in polling loop\n";
#warning "Should do something here!"
          }
//           status.currState = rod.getPrimState();
        }        // Give status lock

        // Don't do when have any locks...
        sched_yield();

        rods ++;
      }         // Next ROD

//       std::cout << "Polled " << rods << " RODs\n";

      if(stopPolling) {
        break;
      }
    }  // While (1)
  }
#endif
}

//           } catch (SctPixelRod::VmeException &v) {
//             std::cout << "VmeException in polling loop: " << v.getErrorCode() << " Class: ";

//             switch(v.getErrorClass()) {
//             case SctPixelRod::VmeException::OK: std::cout << "OK\n"; break;
//             case SctPixelRod::VmeException::INIT_ERROR: std::cout << "Init error\n"; break;
//             case SctPixelRod::VmeException::BUS_ERROR: std::cout << "Bus error\n"; break;
//             case SctPixelRod::VmeException::MAP_ERROR: std::cout << "Map error\n"; break;
//             case SctPixelRod::VmeException::DMA_ERROR: std::cout << "Dma error\n"; break;
//             default: std::cout << "Unknown error class\n"; break;
//             }

//             SctPixelRod::VmePort *p = v.getPort();

//             std::cout << "Port: code: " << p->getLastErrcode() << " " 
//                       << p->getErrorMessage(p->getLastErrcode()) << std::endl;
