#ifndef SCAN_HEADER__H
#define SCAN_HEADER__H

#include "dataTypes.h"
#include "CommonWithDsp/processor.h"
#include "CommonWithDsp/sctStructure.h"
	
struct ScanHeader {
  UINT16 version;		//header version
  UINT16 length;		//header length
  UINT32 runNumber;		
  UINT32 scanNumber;

  char moduleName[16];	        //Serial number

  UINT16 scanType;	        //As defined in ABCDscans.h
  UINT16 npoints;		//Number of scan points

  UINT32 size;			//Size of data block in 16bit words
  UINT16 dataType;		//Datatype as defined in dataTypes.h
  UINT16 width;			//Width of data - either 0 (N/A), 16, 32bits

  ABCDModule config;            // Don't need to know how big it is (look at length)

  UINT32 pntPoints;             // Index to point data from beginning of file
  UINT32 pntEvents;             // Index to event data from beginning of file
  UINT32 pntErrors;             // Index to error data from beginning of file
  UINT32 pntData;               // Index to histogram data from beginning of file
};

struct scan_result_ptrs {
  ScanHeader header;

  FLOAT32* points; 			//Point values
  UINT32* nEvents;  			//No. events
  UINT32* nErrorEvents;  		//No. Error Events
  void* data;					//data
};

#endif
