package SctApi.gui;

import java.awt.BorderLayout;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JScrollPane;

public class ScanList extends JFrame {
    JList theList;
    Sct_SctApi.SctApi api;
    Sct_SctApi.Scan[] scans;

    public ScanList(Sct_SctApi.SctApi a, Sct_SctApi.Scan[] s) { 
        super("Scan Selector");

        api = a; scans = s;

        System.out.println("Found " + scans.length + " scans");

        Object [] myScans = new Object[scans.length];

        for(int si=0; si < scans.length; si++) {
            Sct_SctApi.Scan thisScan = scans[si];

            if(thisScan != null) {
                thisScan.print();

                myScans[si] = "" + si;
            }
        }

        theList = new JList(myScans);
        getContentPane().add(new JScrollPane(theList));

        JButton openButton = new JButton("Open scan");

        openButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    int index = theList.getSelectedIndex();

                    if(index < 0) return;

                    JFrame frame = new ScanView(api, scans[index]);

                    frame.addWindowListener(new WindowAdapter() {
                            public void windowClosing(WindowEvent e) {
                                e.getWindow().dispose();
                            }
                        });
                    frame.pack();
                    frame.setVisible(true);

                    dispose();
                }
            });

        getContentPane().add(openButton, BorderLayout.SOUTH);
    }
}
