#include <cmath>
using namespace std;

class Comp {
public:
    Comp(double tolerance) : tolerance(tolerance), n(0), sum(0), sum2(0) {}
    bool comp(double f1, double f2) {
	double diff = f1 - f2;
	++n;
	sum += diff;
	sum2 += diff * diff;
	return (fabs(diff) > tolerance);
    }
    
    double mean() {return sum/n;}
    double stddev() {return sqrt(sum2/n - mean() * mean());}
    bool setTolerance(double tolerance) {
	if (n==0) {
	    this->tolerance = tolerance;
	    return true;
	}
	return false;
    }
    
private:
    double tolerance;
    int n;
    double sum;
    double sum2;
};
