#include "Service.h"
#include "Sct/IpcObjectException.h"

using namespace SctArchivingService;

int main(int argc, char** argv) {
    Sct::setExceptionHandlers(argv[0]);

    bool multiThreaded = false; //Choose single/multi-threaded 
    IPCCore::init(multiThreaded); 
    
    try {
	//Raw and Fitted objects
	ArchivingService arch;
	if (!arch.publish()) {
	    throw Sct::IpcObjectException("Failed to publish ArchivingService", __FILE__, __LINE__);
	}
	    
	arch.run();
    } catch (Sct::Throwable& e){
	e.sendToMrs(MRS_FATAL); 
	std::terminate(); 
    }
}
