#include "ServiceRaw.h"
#include "archiving/ArchRawScanResult.h"
#include "archiving/ArchFitScanResult.h"

#include "Sct/SctNames.h"
//#include "SCT/ISManager.h"
#include "Sct/IS/IOManagerIS.h"
#include "SctData/TestResult.h"
#include "SctData/RawScanResult.h"
//#include "Sct/shared_ptr_utility.h"

using namespace Sct;
using namespace SctData;
using namespace Sct::IS;
using namespace boost;


namespace SctArchivingServiceRaw {

ArchivingServiceRaw::ArchivingServiceRaw() {}

void ArchivingServiceRaw::runRaw() {
    cout<<" I am in ArchivingServiceRaw::runRaw() " <<endl;
    IPCPartition& p = SctNames::getPartition();
    ISInfoReceiver r(p);
    r.subscribe( "EventData", ".*Raw.*", ISCallbackRaw,this);
    r.run();
}


void ArchivingServiceRaw::ISCallbackRaw(ISCallbackInfo * isc) {
    cout<<" I am in ArchivingServiceRaw::ISCallbackRaw " <<endl;
    ArchivingServiceRaw* a = static_cast<ArchivingServiceRaw*>(isc->parameter());
    a->archiveRaw(isc);
}


void ArchivingServiceRaw::archiveRaw(ISCallbackInfo * isc) {
    cout<<" I am in ArchivingServiceRaw::archiveRaw " <<endl;
    
    if (isc->reason() != ISInfoCreated && isc->reason() != ISInfoUpdated )
        return;

    //Serializable* ob = ISManager::getManager().getFromIS(*isc);
    shared_ptr<Serializable> ob = IOManagerIS::instance().read(*isc);
    if (ob == 0) {
        cerr << "Failed to get object from IS" << endl;
        return;
    }
    //RawScanResult* raw = dynamic_cast<RawScanResult*>(ob);
    shared_ptr<RawScanResult> raw = dynamic_pointer_cast<RawScanResult>(ob);
    if (raw == 0) {
        cerr << "object wasn't as expected" << endl;
	//delete ob;
        return;
    }

    
    cout << "Archiving  RawScanResult: " << endl;
    //Store RawScanObject: 
    ArchRawScanResult archraw(*raw);
    archraw.SetUNIXDir();
    archraw.SaveRawScan();
    archraw.RawScanIsPersisted();

    //delete raw;    
    cout << "Test Raw complete" << endl;
}


}
