#ifndef ArchFitScanResult_H
#define ArchFitScanResult_H

#include <vector>
#include <is/isinfo.h>
#include "SctData/ConfigurationVariable.h"
#include "SctData/FitScanResult.h"
#include "SctData/FitScanResultIOHelper.h"
#include "SctData/FitObject.h"
#include "Sct/SctNames.h"
#include "ArchScanResult.h"

class TFile;
class TDirectory;
class TObject;
class TSystem;
class TNamed;
class TString;
class TObjString;
class TH1D;
class TH2;


using namespace SctData;
using namespace Sct;


class ArchFitScanResult: public ArchScanResult {
  private:
    
  //FitScanResultIOHelper Archfit;   ?????
//   vector<TF1*> AllLinkFits;
//   vector<TF1*> AllChipFits;
//   vector<TF1*> AllChannelFits;
    const FitScanResult* theFit;

  public:
    ArchFitScanResult(const FitScanResult &);
    ArchFitScanResult(); 
    ~ArchFitScanResult();
    
    void SetFitScan(FitScanResult & );

    void SaveFitScan();
    void SaveFitScan(FitScanResult& );
    bool FitScanIsPersisted(); 
    bool FitScanIsPersisted(FitScanResult& );
    bool FitScanIsPersisted(long scanNumber, long runNumber, string moduleName, const ConfigurationVariable& variable);
    //void DeletePersFitObj(FitScanResult& );  //!!Problem  
    //void DeletePersFitObj();                 //!!Problem
    FitScanResult* CreateFitScanResult();
    FitScanResult* CreateFitScanResult(FitScanResult&);
    FitScanResult* CreateFitScanResult(long scanNumber, long runNumber, string moduleName, const ConfigurationVariable& variable);


    void SaveFitComment();
 


};


 


#endif
