#include <iostream>

#include <libxml/parser.h>
#include <libxml/xpath.h>
#include <libxml/xinclude.h>

static xmlDocPtr getDocument(char *fname);
static void findSomething(xmlDocPtr doc, char *exp);

int main(int argc, char **argv) {
  xmlXPathInit();

  xmlDocPtr document;
  if(argc > 2) {
    document = getDocument(argv[1]);
  } else {
    std::cout << "Usage: query xmlfile xpathQuery\n";
    throw "Goodbye";
  }

  std::cout << "Read file\n";

  if(document) {
    findSomething(document, argv[2]);
  } else {
    std::cout << "Document not parsed!\n";
  }
}

xmlDocPtr getDocument(char *filename) {
  xmlDocPtr document;

  document = xmlParseFile(filename);

  return document;
}

void findSomething(xmlDocPtr doc, char *expression) {
  xmlXPathContextPtr cntxt = xmlXPathNewContext(doc);

  std::cout << "Created xpath context\n";
  std::cout << "Expression: " << expression << std::endl;

  xmlXPathObjectPtr result 
    = xmlXPathEval((unsigned char *)expression, cntxt);

  if(result) {
    std::cout << "Got a result \n";

    std::cout << "Type is: " << (int)result->type << std::endl;

    if(result->type == XPATH_NODESET && result->nodesetval) {
      std::cout << "There are : " << result->nodesetval->nodeNr << " nodes\n";

      //      std::cout << "Names: \n";
      for(int i=0; i<result->nodesetval->nodeNr; i++) {
	xmlNodePtr curr = result->nodesetval->nodeTab[i];

	xmlElemDump(stdout, doc, curr);

//  	std::cout << curr->name << std::endl;
	//	std::cout << curr->content << std::endl;
      }
    } else {
      std::cout << "Bad type or no data\n";
    }

    xmlXPathFreeObject(result);
  } else {
    std::cout << "No result\n";
  }
}

