package SctApi.conf.gui;

import javax.swing.event.AncestorListener;
import javax.swing.event.AncestorEvent;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import java.io.File;

import org.omg.CORBA.IntHolder;
import org.omg.CORBA.StringHolder;

import sctConf.*;

public class MURPanel extends JPanel {
    sctConf.Configuration config;
    ConfigGui.Rod rod;

    int index;
    boolean editable;

    JTextField [] current;
    JTextField [] delay;
    JTextField [] markSpace;
    JTextField [] threshold0;
    JTextField [] delay0;
    JTextField [] threshold1;
    JTextField [] delay1;
    JTextField [] txFibre;
    JTextField [] rx0Fibre;
    JTextField [] rx1Fibre;

    int mur;

    /// If type is 1 then read only sub-panel otherwise editable
    public MURPanel(Configuration conf, ConfigGui.Rod r, int i, boolean edit) {
        rod = r;
        config = conf;
        index = i;
        editable = edit;

        setLayout(new GridLayout(0, 1));

        IntHolder MUR = new IntHolder(), num = new IntHolder();

        try {
            config.translateFromROD(rod.partition(), rod.crate(), rod.index(), index*6, MUR, num);
        } catch(ConfigurationException e) {
            MUR.value = -1;
        }

        mur = MUR.value;

        if(!editable) {
            setBorder(BorderFactory.createTitledBorder("MUR " + MUR.value + " position " + (i+1)));
        }

        current = new JTextField [6]; 
        delay = new JTextField [6] ;
        markSpace = new JTextField [6]; 
        threshold0 = new JTextField [6]; 
        delay0 = new JTextField [6]; 
        threshold1 = new JTextField [6]; 
        delay1 = new JTextField [6];
        txFibre = new JTextField [6];
        rx0Fibre = new JTextField [6];
        rx1Fibre = new JTextField [6];


        for(int m=0; m<6; m++) {
            int channel = index*6 + m;

            JPanel channelPanel = new JPanel();
            if(editable) {
                channelPanel.setBorder(BorderFactory.createTitledBorder("Position " + (m+1)));
            }
            channelPanel.setLayout(new GridLayout(0, 1));

            try {
                StringHolder serial = new StringHolder();

                config.translateFromROD(rod.partition(), rod.crate(), rod.index(), channel, MUR, num);
                config.translateToSN(MUR.value, num.value, serial);

                channelPanel.add(new JLabel(serial.value));
            } catch(ConfigurationException e) {
                JPanel modulePanel = new JPanel();

                modulePanel.add(new JLabel("No Module in position " + m));

                JButton addButton = new JButton("Add");
                addButton.addActionListener(new AddActionListener(mur, m));
                modulePanel.add(addButton);

                channelPanel.add(modulePanel); 
            }

            int [] mappings = new int[48*3];

            try {
                BOCChannelConfig boc = config.getBOCConfig(rod.partition(), rod.crate(), rod.index(), channel); 

                if(!editable) {
                    channelPanel.add(new JLabel(boc.current + " " + boc.delay + " " + boc.markSpace + " " + mappings[channel*3]));
                    channelPanel.add(new JLabel(boc.threshold0 + " " + boc.delay0));
                    channelPanel.add(new JLabel(boc.threshold1 + " " + boc.delay1));
                } else {
                    // Editable
                    // TX fibre
                    JPanel txPanel = new JPanel();
                    txPanel.add(new JLabel("Current: "));
                    current[m] = new JTextField("" + boc.current, 4);
                    txPanel.add(current[m]);
                    txPanel.add(new JLabel(" Delay: "));
                    delay[m] = new JTextField("" + boc.delay, 4);
                    txPanel.add(delay[m]);
                    txPanel.add(new JLabel("MarkSpace: "));
                    markSpace[m] = new JTextField("" + boc.markSpace, 4);
                    txPanel.add(markSpace[m]);

                    txPanel.add(new JLabel("TX Fibre: "));
                    txFibre[m] = new JTextField("" + mappings[channel * 3+0], 4);
                    txPanel.add(txFibre[m]);

                    channelPanel.add(txPanel);
 
                    JPanel rx0Panel = new JPanel();
                    rx0Panel.add(new JLabel("Threshold: "));
                    threshold0[m] = new JTextField("" + boc.threshold0, 4);
                    rx0Panel.add(threshold0[m]);
                    rx0Panel.add(new JLabel(" Delay: "));
                    delay0[m] = new JTextField("" + boc.delay0, 4);
                    rx0Panel.add(delay0[m]);
                    channelPanel.add(rx0Panel);

                    JPanel rx1Panel = new JPanel();
                    rx1Panel.add(new JLabel("Threshold: "));
                    threshold1[m] = new JTextField("" + boc.threshold1, 4);
                    rx1Panel.add(threshold1[m]);
                    rx1Panel.add(new JLabel(" Delay: "));
                    delay1[m] = new JTextField("" + boc.delay1, 4);
                    rx1Panel.add(delay1[m]);
                    channelPanel.add(rx1Panel);

                    channelPanel.addAncestorListener(new CheckDispose(this, m));
                }
            } catch(ConfigurationException e) {
                channelPanel.add(new JLabel("No Configuration for BOC"));
            }
            add(channelPanel);
        }
    }

    class CheckDispose implements AncestorListener {
        MURPanel mur;
        int index;

        public CheckDispose(MURPanel m, int i) {
            index = i;
            mur = m;
        }

        public void ancestorAdded(AncestorEvent e) {
        }

        public void ancestorMoved(AncestorEvent e) {
        }

        public void ancestorRemoved(AncestorEvent e) {
            if(mur.mur >= 0 ) {
                BOCChannelConfig bConf = new BOCChannelConfig();

                try {
                    bConf.current = Short.parseShort(mur.current[index].getText());
                    bConf.delay = Short.parseShort(mur.delay[index].getText());
                    bConf.markSpace = Short.parseShort(mur.markSpace[index].getText());
                    bConf.threshold0 = Short.parseShort(mur.threshold0[index].getText());
                    bConf.delay0 = Short.parseShort(mur.delay0[index].getText());
                    bConf.threshold1 = Short.parseShort(mur.threshold1[index].getText());
                    bConf.delay1 = Short.parseShort(mur.delay1[index].getText());
                } catch(NumberFormatException ex) {
                } catch(NullPointerException ex) {
                }

                int channel = mur.index*6 + index;

                try {
                    mur.config.configureBOCChannel(mur.mur, mur.index, bConf);
//                     mur.config.setBOCConfig(mur.rod.partition(), mur.rod.crate(), mur.rod.index(), channel, bConf);
                } catch(ConfigurationException ex) {
                    System.out.println("Failed to update configuration for mur " + mur.mur);
                }
            }
        }
    }

    class AddActionListener implements ActionListener {
        int index;

        AddActionListener(int mur, int i) {
            index = i;
        }

        public void actionPerformed(ActionEvent e) {
            try {
                String filename = getFileName();
                if(filename != null)
                    config.configureModuleFromFile(filename);
            } catch(ConfigurationException c) {
                System.out.println("Module not created: configuration " + c);
                System.out.println("Failed to add module from file (" + mur + ":" + index + ")");
            }
            /*mur, index, mur, ((index+1) % 6) + 1, */         
        }
    }

    static JFileChooser fileChooser;

    { fileChooser = null; }

    static String getFileName() {
        if(fileChooser == null) {
            fileChooser = new JFileChooser();
        }

        if(fileChooser.showDialog(null, "Pick module configuration file") == JFileChooser.APPROVE_OPTION) {
          File file = fileChooser.getSelectedFile();
          return file.toString();
        } else {
          return null;
        }
    }
}
