package SctApi.conf.gui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import javax.swing.event.MouseInputAdapter;

import org.omg.CORBA.IntHolder;
import org.omg.CORBA.StringHolder;

import sctConf.*;

public class RODView extends JFrame {
    sctConf.Configuration config;
    ConfigGui.Rod rod;

    public RODView(Configuration conf, ConfigGui.Rod r) {
        super("Modules in a ROD");
        rod = r;
        config = conf;

        JPanel buttons = new JPanel();

        JButton close = new JButton("Close");
        close.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    dispose();
                }
            });
        buttons.add(close);

        getContentPane().add(buttons, BorderLayout.SOUTH);

        JPanel centre = new JPanel();

        centre.setLayout(new GridLayout(2, 4));

        for(int i=0; i<8; i++) {
            JPanel murPanel = new MURPanel(conf, rod, i, false);

            murPanel.addMouseListener(new MouseAdapter(i));

            centre.add(murPanel);
        }

        getContentPane().add(centre, BorderLayout.CENTER);

        JPanel top = new JPanel();

        try {
            RodConfig rConf = config.getRodConfig(rod.partition(), rod.crate(), rod.index());

            top.setLayout(new GridLayout(4, 2));
            top.add(new JLabel("BaseAddress:"));
            top.add(new JLabel(Long.toHexString(rConf.baseAddress)));
            top.add(new JLabel("IPRAM:"));
            top.add(new JLabel(rConf.slaves[0].ipramFile));
            top.add(new JLabel("IDRAM:"));
            top.add(new JLabel(rConf.slaves[0].idramFile));
            top.add(new JLabel("EXT:"));
            top.add(new JLabel(rConf.slaves[0].extFile));
        } catch (ConfigurationException c) {
            top.setLayout(new GridLayout(1, 1));
            top.add(new JLabel("No Rod configuration information"));
        }
        getContentPane().add(top, BorderLayout.NORTH);
    }

    class MouseAdapter extends MouseInputAdapter {
        int index;

        public MouseAdapter(int i) { index = i; }

        public void mouseClicked(MouseEvent e) {
            JFrame frame = new JFrame("MUR editor");

            frame.getContentPane().add(new MURPanel(config, rod, index, true), BorderLayout.CENTER);

            frame.addWindowListener(new WindowAdapter() {
                    public void windowClosing(WindowEvent e) {
                        e.getWindow().dispose();
                    }
                });
            frame.pack();
            frame.setVisible(true);
        }
    }
}
