/*
 * TablesDisplayPane.java
 *
 * Created on 23 June 2003, 15:43
 */

package DisplayGUI;
import javax.swing.JTable;
import javax.swing.event.*;
import javax.swing.ListSelectionModel;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.JOptionPane;
import java.util.Vector;
import Sct_CalibrationController.TestData;
/**
 *
 * @author  robinson
 */
public class TablesDisplayPane extends javax.swing.JPanel implements TestDataInfo,TableModelListener,ListSelectionListener,displayParams {
    gui guiControl;
    guiTableAdapter[] resultTable = new guiTableAdapter[2];
    JTable[] table = new JTable[2];
    Vector[] objectNames = new Vector[2];
    ListSelectionModel[] rowSM = new ListSelectionModel[2];
    String table1,table2;
    int rowSelected=-1;
    boolean selectionListenerIsActive=true;

    public TablesDisplayPane(gui parent) {
        guiControl=parent;
        for(int i=0;i<2;i++) {
          resultTable[i] = new guiTableAdapter();
          resultTable[i].addTableModelListener(this);
          table[i] = new JTable(resultTable[i]);
          table[i].setFont(tableFont);
          table[i].setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
//          table[i].addKeyListener(this);
          rowSM[i] = table[i].getSelectionModel();
          rowSM[i].addListSelectionListener(this);

        }

        table1 = "null";
        table2 = "null";



//        setTableTitles();
        initComponents();
        table[0].addMouseListener(new tables0MouseAdapter());  // popup menu on second table only
        table[1].addMouseListener(new tables1MouseAdapter());  // popup menu on second table only
        setBorder(new javax.swing.border.TitledBorder(null, "Data", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", 0, 11), new java.awt.Color(0, 0, 153)));
 
    }
    
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jScrollPane1 = new javax.swing.JScrollPane(table[0]);
        table1Title = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane(table[1]);
        table2Title = new javax.swing.JLabel();

        setLayout(new java.awt.GridBagLayout());

        setBackground(new java.awt.Color(255, 255, 255));
        jScrollPane1.setBackground(new java.awt.Color(255, 255, 255));
        jScrollPane1.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jScrollPane1.setMinimumSize(new java.awt.Dimension(300, 150));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(300, 200));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 2;
        gridBagConstraints.ipady = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weighty = 0.4;
        add(jScrollPane1, gridBagConstraints);

        table1Title.setFont(new java.awt.Font("Arial", 0, 12));
        table1Title.setForeground(new java.awt.Color(51, 0, 153));
        table1Title.setText("Table 1");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weighty = 0.05;
        add(table1Title, gridBagConstraints);

        jScrollPane2.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jScrollPane2.setMinimumSize(new java.awt.Dimension(300, 150));
        jScrollPane2.setPreferredSize(new java.awt.Dimension(300, 200));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weighty = 0.4;
        add(jScrollPane2, gridBagConstraints);

        table2Title.setFont(new java.awt.Font("Arial", 0, 12));
        table2Title.setForeground(new java.awt.Color(51, 0, 153));
        table2Title.setText("Table 2");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weighty = 0.05;
        add(table2Title, gridBagConstraints);

        jScrollPane1.addMouseListener(new tables0MouseAdapter());  // popup menu on second table only
        jScrollPane2.addMouseListener(new tables1MouseAdapter());  // popup menu on second table only

    }//GEN-END:initComponents
  
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    public javax.swing.JLabel table1Title;
    public javax.swing.JLabel table2Title;
    // End of variables declaration//GEN-END:variables
    public java.awt.Insets getInsets() {
        return new java.awt.Insets(10,10,10, 10);
    }
    
    public void tableChanged(javax.swing.event.TableModelEvent e) {
        if(table1.equals("null")) table1Title.setText("");
        else table1Title.setText(table1+" : "+Integer.toString(resultTable[0].getRowCount()));
        if(table2.equals("null")) table2Title.setText("");
        else table2Title.setText(table2+" : "+Integer.toString(resultTable[1].getRowCount()));

    }
//    public void setTableTitles(String title1, String title2) {
//        table1 = new String(title1);
//        table2 = new String(title2);
//        tableChanged(null);
//    }
    public void setTableTitles(String title1, String title2) {
        table1 = new String(title1);
        table2 = new String(title2);
        table1Title.setText(table1+" : "+Integer.toString(resultTable[0].getRowCount()));
        table2Title.setText(table2+" : "+Integer.toString(resultTable[1].getRowCount()));        
    }
    public int getRowCount(int table) {
        if(resultTable[table]==null) return 0;
        return resultTable[table].getRowCount();
        }
    public void setTable1Title(String title) {
        table2 = new String(title);
        table2Title.setText(table2+" : "+Integer.toString(resultTable[1].getRowCount()));        
    }  
    public void refresh(int thisModuleGroup, java.util.Vector tableContents) {
        selectionListenerIsActive=false;
        resultTable[thisModuleGroup].reTable(tableContents);
        selectionListenerIsActive=true;
        javax.swing.table.TableColumn column = table[thisModuleGroup].getColumnModel().getColumn(0);
        column.setPreferredWidth(100);
        }
    public void refresh(Vector[] tableContents, int table0RowSelect, int table1RowSelect) {
        selectionListenerIsActive=false;
        
        for(int i=0;i<2;i++) {
               objectNames[i] = new Vector(); 
               resultTable[i].reTable(tableContents[i]);
                javax.swing.table.TableColumn column = table[i].getColumnModel().getColumn(0);
                column.setPreferredWidth(110);
                }
        selectionListenerIsActive=true;
        if(table0RowSelect!=-1) rowSM[0].setSelectionInterval(table0RowSelect,table0RowSelect);
        }
    public void refresh1(Vector newObjectNames, Vector tableContents, String title) {
        objectNames[1] = new Vector(newObjectNames);
        table2 = new String(title);
        selectionListenerIsActive=false;
        resultTable[1].reTable(tableContents);
        selectionListenerIsActive=true;
        javax.swing.table.TableColumn column = table[1].getColumnModel().getColumn(0);
        column.setPreferredWidth(110);        
        }



    public String getSelectedObject() {
        int selectedRow = rowSM[1].getMinSelectionIndex();
        if(selectedRow==-1 || objectNames[1].size()==0) return null;
        return (String)objectNames[1].elementAt(selectedRow);
        }
    public int getSelectedTest() {
        return rowSM[0].getMinSelectionIndex();
        }


    
    /** method required by ListSelectionListener interface */
    public void valueChanged(ListSelectionEvent e) {
                 if(!selectionListenerIsActive) {
                         selectionListenerIsActive=true;
                         return;
                         }

               //Ignore extra messages.
              if (e.getValueIsAdjusting()) return;
        
              ListSelectionModel lsm = (ListSelectionModel)e.getSource();

              int thisTable = (lsm==rowSM[0]) ? 0 : 1;

              if (lsm.isSelectionEmpty()) {
                 //no rows are selected
                  if(thisTable==0) {
//                       if(resultTable[0].getRowCount()>0 && rowSelected>=0) {
                         // Protect for the following case:
                         // The table has been updated by "resultTable[0].fireTableChanged(null)"
                         // but we want to keep the same selection (reselect the previously selected row)
                         // without updating the main display
//                         System.out.println("Reselecting row "+rowSelected);
//                         selectionListenerIsActive=false;
//                         lsm.setSelectionInterval(rowSelected,rowSelected);
//                         return;
//                         }
                                             
                       guiControl.isInterface.setISFilter(-1);
                       guiControl.testDataInterface.setTestFilter(-1);
                       guiControl.sctdbDataInterface.setTestFilter(-1);
                       guiControl.displayPane.setDisplayColors();
                       guiControl.displayPane.refreshDisplay();
                       rowSelected=-1;
                       }
              } else {

// ok, a row has been selected. If this is a IS_MONITOR display, then check if color scale needs updating   
                 int minRow=lsm.getMinSelectionIndex();
                 int maxRow=lsm.getMaxSelectionIndex();   
                 int nselected = maxRow-minRow+1;  
                 if(guiControl.displayStatus.getStatus()==DisplayStatus.IS_MONITOR) {
// if more than one row is selected, assume they want to delete them
                   if(nselected>1) {
                     int response = JOptionPane.showConfirmDialog(null,"Are you sure you want to delete these "+nselected+" objects from IS?","Confirm Deletion Request",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE);
                     if(response==JOptionPane.NO_OPTION) {
                             lsm.setSelectionInterval(minRow,minRow);
                             return; 
                             }
                     // delete the objects
                     if(thisTable==0) guiControl.isInterface.removeTests(minRow,maxRow);
//                     else deleteSelectedDataObjects();
                     updateTables();
                     return;
                     } 
                      if(thisTable!=0) return;  
                      rowSelected=-1;
                      guiControl.isInterface.setISFilter(minRow); 
                      guiControl.selectorPane.initParamList(); // maybe require change of parameter menu
                      guiControl.colorScalePane.setColorScale(); 
//                      System.out.println("TablesDisplayPane:: setDisplayColors");
                      guiControl.displayPane.setDisplayColors();      
                      guiControl.displayPane.refreshDisplay();
                      ModuleCell lastClickedCell;
                      if((lastClickedCell=guiControl.displayPane.getLastClickedCell())!=null) listISObjects(lastClickedCell);
                     }  // IS_MONITOR
                 else if(guiControl.displayStatus.getStatus()==DisplayStatus.TEST_DATA) {
                      if(thisTable!=0) return;
                      rowSelected=minRow;
                      guiControl.testDataInterface.setTestFilter(minRow);
                      guiControl.selectorPane.initParamList(); // maybe require change of parameter menu
                      guiControl.colorScalePane.setColorScale(); // ditto for color scale
//                      System.out.println("TablesDisplayPane:: setDisplayColors");
                      guiControl.displayPane.setDisplayColors();
                      guiControl.displayPane.refreshDisplay();
//                      updateTables();  // uncomment this to make an infinite loop!
                      listTestResults();
                      }
                 else if(guiControl.displayStatus.getStatus()==DisplayStatus.SCTDB_DATA) {
                      if(thisTable!=0) return;
                      rowSelected=minRow;
                      guiControl.sctdbDataInterface.setTestFilter(minRow);
                      guiControl.selectorPane.initParamList(); // maybe require change of parameter menu
                      guiControl.colorScalePane.setColorScale(); // ditto for color scale
 //                     System.out.println("TablesDisplayPane:: setDisplayColors");
                      guiControl.displayPane.setDisplayColors();
                      guiControl.displayPane.refreshDisplay();
//                      updateTables();  // uncomment this to make an infinite loop!
                      listTestResults();
                      }
                     
 
              }
            }

    public void listISObjects(ModuleCell thisCell) {

       Vector tableContents = new Vector();
       Vector theLine = new Vector();
       theLine.addElement("Serial No");
       theLine.addElement("Run No");
       theLine.addElement("Scan No");
       theLine.addElement("Data");
       tableContents.addElement(theLine);
       String title = "null";
       String thisSN = thisCell.getSerialNo();
       String[] ISObjects = guiControl.isInterface.getISObjects(thisSN);
       Vector objectsVector = new Vector();

       for(int i=0;i<ISObjects.length;i++) {
            objectsVector.addElement(ISObjects[i]);
            String[] objectParts = ISObjects[i].split("\\.");
            theLine = new Vector();
            theLine.addElement(objectParts[4]);
            theLine.addElement(objectParts[2]);
            theLine.addElement(objectParts[3]);
            theLine.addElement(objectParts[1]);
            tableContents.addElement(theLine);
            }
          title =guiControl.selectorPane.getDisplayParameter()+" for "+thisSN;
          refresh1(objectsVector,tableContents,title);
        }
     public void listTestResults() {
        int status = guiControl.displayStatus.getStatus();
        String testParameter = guiControl.selectorPane.getDisplayParameter();
        Vector moduleList = guiControl.config.getSortedVector(guiControl.displayPane.getSCTView());
        Vector theLine = new Vector();
        Vector table = new Vector();
        Vector objectsVector = new Vector();
        theLine.addElement("Serial No");
        if(status==DisplayStatus.SCTDB_DATA) {
           theLine.addElement("Location");
           theLine.addElement("Date");
           }
        theLine.addElement(testParameter);
        table.addElement(theLine);
        for(int i=0;i<moduleList.size();i++) {
                 String thisSN = (String)moduleList.elementAt(i);
                 ModuleCell thisCell = (ModuleCell)guiControl.config.getModuleCell(guiControl.displayPane.getSCTView(),thisSN);
                 theLine=new Vector();
                 theLine.addElement(thisSN);
                 if(status==DisplayStatus.SCTDB_DATA) {
                   int testIndex = guiControl.sctdbDataInterface.getTestIndex();
                   if(testIndex<0) continue;
                   String objectName ="SCTDBData."+testNames[testIndex]+"."+guiControl.sctdbDataInterface.getLocation()+"."+thisSN;
                   if(Sct.IS.SctNames.getISRepository().contains(objectName)) {
                     SCTDB_Data result = new SCTDB_Data(); 
                     Sct.IS.SctNames.getISRepository().getValue(objectName, result); 
                     theLine.addElement(result.testLocation);
                     theLine.addElement(result.testDate);
                     }
                   else {
                     theLine.addElement(" - ");
                     theLine.addElement(" - ");
                    }
                 }
                 ColorScale thisColorScale;
                 if((thisColorScale = guiControl.colorScalePane.getColorScale())!=null) theLine.addElement(thisColorScale.getLabel(thisCell.getData()));
                 else theLine.addElement("No Data");
                 table.addElement(theLine);
                 }      
          String title = (status==DisplayStatus.TEST_DATA && guiControl.displayPane.getDisplayOption()==2) ? testParameter+" Comparisons" : testParameter+" Results ";
          refresh1(objectsVector,table,title);     
         }   

    public void updateTables(boolean keepSelections) {
         changeTables(keepSelections);
         }
    public void updateTables() {
         changeTables(false);
         }

    private void changeTables(boolean keepSelections) {
      Vector theLine = new Vector();
      int table0Select=-1;
      int table1Select=-1;
      String title0="";
      String title1="";
      Vector[] tableContents = new Vector[2];
      tableContents[0] = new Vector();
      tableContents[1] = new Vector();
      Vector ISObjectNames[] = new Vector[2];
      ISObjectNames[0] = new Vector();
      ISObjectNames[1] = new Vector();

      int previousSelection = keepSelections ? getSelectedTest() : -1;

      int view = guiControl.displayPane.getSCTView();

      switch(guiControl.displayStatus.getStatus()) {
          case DisplayStatus.MODULE_GROUP_SELECTION :
             title0 = "Group 1 modules";
             title1 = "Group 2 modules";
             theLine.addElement("Serial No");
             String title = (view<4) ? "Row" : "Quadrant";
             theLine.addElement(title);
             theLine.addElement("Posn");
             theLine.addElement("MUR");
             tableContents[0].addElement(theLine);
             tableContents[1].addElement(theLine);
             Vector moduleList = guiControl.config.getSortedVector(view);
             for(int i=0;i<moduleList.size();i++) {
               String thisSN = (String)moduleList.elementAt(i);
               ModuleCell thisCell = (ModuleCell)guiControl.config.getModuleCell(view,thisSN);
               int thisGroup = thisCell.getModuleGroup();
               if(thisGroup<0) continue;
               theLine = new Vector();
               theLine.addElement(thisSN);
               if(view<4) {
                    theLine.addElement(Integer.toString(thisCell.getRow()));
                    theLine.addElement(Integer.toString(thisCell.getPosition()));
                    }
               else {
                    theLine.addElement(thisCell.getQuadrant());
                    theLine.addElement(thisCell.getEndCapPosition());
                    }

               theLine.addElement(Integer.toString(thisCell.getMUR()));
               tableContents[thisGroup].addElement(theLine);
               }
             break;
           case DisplayStatus.IS_MONITOR:
               title0 = "Tests";
               title1 = "IS Raw Data Objects";
               theLine = new Vector();
               theLine.addElement("Serial No");
               theLine.addElement("Run No");
               theLine.addElement("Scan No");
               theLine.addElement("Data");
               tableContents[1].addElement(theLine);
               tableContents[0] = guiControl.isInterface.getTestTableList();
               if(tableContents[0].size()>1) table0Select=tableContents[0].size()-2; // remember titles!!               
               break;
           case DisplayStatus.TEST_DATA:
               int testType = guiControl.testDataInterface.getListFilterIndex();
               title0 = (testType==-1) ? "Number of Tests " : "Number of "+testMenuNames[testType]+" Tests ";
               String testParameter = guiControl.selectorPane.getDisplayParameter();
               title1 = testParameter+ " Results";
               theLine = new Vector();
               theLine.addElement("Serial No");
               theLine.addElement(testParameter);
               tableContents[1].addElement(theLine);
               tableContents[0] = guiControl.testDataInterface.getTestTableList();
               if(tableContents[0].size()>1) {
                     if(previousSelection<=tableContents[0].size()-2 && previousSelection>=0) table0Select=previousSelection;
                     else table0Select=tableContents[0].size()-2; // remember titles!!   
                     }

               break;
           case DisplayStatus.SCTDB_DATA:
               testType = guiControl.sctdbDataInterface.getListFilterIndex();
               title0 = (testType==-1) ? "Number of Tests " : "Number of "+testMenuNames[testType]+" Tests ";
               testParameter = guiControl.selectorPane.getDisplayParameter();
               title1 = testParameter+ " Results";
               theLine = new Vector();
               theLine.addElement("Serial No");
               theLine.addElement(testParameter);
               tableContents[1].addElement(theLine);
               tableContents[0] = guiControl.sctdbDataInterface.getTestTableList();
               if(tableContents[0].size()>1) {
                     if(previousSelection<=tableContents[0].size()-2 && previousSelection>=0) table0Select=previousSelection;
                     else table0Select=tableContents[0].size()-2; // remember titles!!   
                     }
               break;
           default:
               return;
              }      
        refresh(tableContents,table0Select,table1Select);
        setTableTitles(title0,title1);
        if(getSelectedTest()==-1) {  // no test now selected, so need to update display manually (otherwise selection listener would do it)
              guiControl.isInterface.setISFilter(-1);
              guiControl.testDataInterface.setTestFilter(-1);
              guiControl.sctdbDataInterface.setTestFilter(-1);
              guiControl.displayPane.setDisplayColors();
              guiControl.displayPane.refreshDisplay();
              rowSelected=-1;
              guiControl.displayPane.setDisplayColors();
              guiControl.displayPane.refreshDisplay();

               }
    }

    public void updateTestTable(String testObjectName, int rowNumber) {
           if(rowNumber==-1) return;
           try {
           TestData testData = new TestData(); 
           Sct.IS.SctNames.getISRepository().getValue(testObjectName, testData); 
           switch(testData.status) {
               case 0:
                 resultTable[0].setValueAt("Executing",rowNumber,1);
                 break;
               case 1:
                 resultTable[0].setValueAt("Completed",rowNumber,1);
                 break;
               case 2:
                 resultTable[0].setValueAt("Aborted",rowNumber,1);
                 break;
               default:
                 resultTable[0].setValueAt("Unknown",rowNumber,1);
               }
             resultTable[0].fireTableCellUpdated(rowNumber,1);
            }catch(Exception updateE){System.err.println("***ERROR updating test status in table list : "+updateE.toString());}
         }


    class tables1MouseAdapter extends java.awt.event.MouseAdapter {
            public void mouseClicked(java.awt.event.MouseEvent e) {
               switch(e.getModifiers()) {
                 case java.awt.event.InputEvent.BUTTON2_MASK:
                 case java.awt.event.InputEvent.BUTTON3_MASK:
                       guiControl.menuBar.showTablesPopupMenu(1,e);
                       break;
                 default:
                 }
            }
    }
    class tables0MouseAdapter extends java.awt.event.MouseAdapter {
            public void mouseClicked(java.awt.event.MouseEvent e) {
               switch(e.getModifiers()) {
                 case java.awt.event.InputEvent.BUTTON2_MASK:
                 case java.awt.event.InputEvent.BUTTON3_MASK:
                       guiControl.menuBar.showTablesPopupMenu(0,e);
                       break;
                 default:
                 }
            }
    }



    
}
