package DisplayGUI;
/** 
Detector parameters. 
**/

public interface TestDataInfo {

   static final String[] testNames = {"ResetTest","RedundancyTest","FullBypassTest","PipelineTest",
"StrobeDelayTest","3PtGainTest","TrimRangeTest","NPtGainTest","NoiseOccupancyTest","TimeWalkTest","LongTermTest","IVScanTest","NMaskTest"};
   static final String[] testMenuNames = {
       "Reset","Redundancy","FullByPass","Pipeline",
       "StrobeDelay","3PtGain","Trim","NPtGain","Noise","TimeWalk","LongTerm","IVscan","NMask"};
   static final String[][] testParameters = {
                {},
                {},
                {"Result Status","Defect Channels","Token","RToken"},
                {"Result Status","Defect Channels","N(bad)"},
                {"Result Status","Defect Channels","Delay"},
                {"Result Status","Defect Channels","vt50 (mV)","vt50 RMS","Gain (mV/fC)","Gain RMS","Offset (mV)","Offset RMS","Output Noise (mV)","Input Noise (enc)","Noise RMS (enc)"},
                {"Result Status","Defect Channels","Range","Target","N(untrimmed)","vt50 (mV)","vt50 RMS","Offset (mV)","Offset RMS","Step size (mV)","Step Size RMS"},
                {"Result Status","Defect Channels","vt50 (mV)","vt50 RMS","Gain (mV/fC)","Gain RMS","Offset (mV)","Offset RMS","Output Noise (mV)","Input Noise (enc)","Noise RMS (enc)"},
                {"Result Status","Defect Channels","Offset","Occupancy","RMS Occupancy","Noise (enc)"},
                {"Result Status","Defect Channels","TimeWalk","TCal"},
                {},
                {},
                {"Result Status","Defect Channels"}  // NMask - no other data
         };
   public double[][] testDataTolerances = {
                {},
                {},
                {0.0,1.0,0.1,0.1},
                {0.0,1.0,1.0},
                {0.0,1.0,3.0},
                {0.0,1.0,50.0,5.0,10.0,1.0,5.0,3.0,2.0,200.0,50.0},
                {0.0,1.0,4.0,200.0,1.0,100.0,10.0,100.0,20.0,10.0,1.0},
                {0.0,1.0,50.0,5.0,10.0,1.0,5.0,3.0,2.0,200.0,50.0},
                {0.0,1.0,10.0,5e-5,5e-5,200.0},
                {0.0,1.0,0.5,0.5},
                {},
                {},
                {0.0,1.0}
          };

   public final String[] chipOptions = {"Worst Chip","Chip M0","Chip S1","Chip S2","Chip S3","Chip S4","Chip E5","Chip M8",
"Chip S9","Chip S10","Chip S12","Chip E13"}; 
   public static final int TEST_RESET=0;
   public static final int TEST_REDUNDANCY=1;
   public static final int TEST_FULLBYPASS=2;
   public static final int TEST_PIPELINE=3;
   public static final int TEST_STROBEDELAY=4;
   public static final int TEST_3PTGAIN=5;
   public static final int TEST_TRIM=6;
   public static final int TEST_NPTGAIN=7;
   public static final int TEST_NOISE=8;
   public static final int TEST_TIMEWALK=9;
   public static final int TEST_LONGTERM=10;
   public static final int TEST_IV=11;
   public static final int TEST_NMASK=12;

   public final boolean[] testIsDefined = {false,false,true,true,true,true,true,true,true,true,false,false,true};


}

