/*
 * PreferencesInterface.java
 *
 * 
 */

package Preferences;
import java.io.*;

/**
 *
 * @author  robinson
 */
public class PreferencesInterface {
    private static PreferencesInterface instance = new PreferencesInterface();
    File preferencesFile = new File(System.getProperty("user.home"),"guiprefs.dat");
    private String[] keys = {"INSTITUTE%","UPLOADDIR%","PSVIEWER%","SCRATCHDIR%"};
    private String[] titles = {"SCTDB Upload Institute","SCTDB Upload Directory","Postscript file Viewer","Scratch Disk"};
    private String[] values;
    public static final int INSTITUTE=0;
    public static final int UPLOAD_DIR=1;
    public static final int PSVIEWER=2;
    public static final int SCRATCH_DIR=3;
    
    /** Creates a new instance of SCTInterface */
    private PreferencesInterface() {
        Refresh();
    }
    
    public static PreferencesInterface getInstance() {
        return instance;
    }

    public void Refresh() {
       values = new String[keys.length];
       for(int i=0;i<values.length;i++) values[i]=new String("Not defined");
       readpreferencesFile();
       if(values[SCRATCH_DIR].equals("Not defined")) setPreference(SCRATCH_DIR,System.getProperty("user.home")); 
       if(values[UPLOAD_DIR].equals("Not defined")) setPreference(UPLOAD_DIR,System.getProperty("user.home"));        
    }
    public String getPreference(int parameter) {
       return values[parameter];
       }
    public String getDescription(int parameter) {
        return titles[parameter];
        }
    public void setPreference(int parameter, String value) {
       values[parameter]=value;
       writepreferencesFile();
       }
   public int getNoPreferences() {
       return keys.length;
       }

    public void readpreferencesFile() {
       String line;
       
       try {
         if(!preferencesFile.exists()) return;
         BufferedReader in = new BufferedReader(new FileReader(preferencesFile));
         while((line=in.readLine())!=null) {
              for(int i=0;i<keys.length;i++) {
                   if(line.indexOf(keys[i])!=-1) {
                          values[i] = line.substring(keys[i].length());
                          break;
                          }
                   }
         }
         in.close();
        } catch(Exception e) {System.out.println("Failed to read Preferences file "+preferencesFile.toString()+" properly. It appears to be corrupted!.");};
     }

    public void writepreferencesFile() {
// if any config data has changed, save it to file.
           File tempFile = new File(System.getProperty("user.home"),"temp.dat");
           try {
              BufferedWriter out = new BufferedWriter(new FileWriter(tempFile));
              String theNewLine;
              for(int i=0;i<keys.length;i++) {
               out.write(keys[i]+values[i]);
               out.newLine();
               }
              out.close();
              boolean deleted = true;
              if(preferencesFile.exists()) deleted = preferencesFile.delete();
              if(deleted) {
                    tempFile.renameTo(preferencesFile);
                    if(preferencesFile.exists()) tempFile.delete();
                    else System.out.println("Preferences file lost!! Backup is at "+tempFile.toString());
                    }
           } catch (Exception e2) { System.out.println("Cant update preferences file");}; 
      }


}
