package ProdDatabase;
import java.io.*;
import java.util.Vector;
import java.util.Hashtable;

import Preferences.*;

public class SignoffData implements ModuleSignoffData {

   Hashtable data;
   String uploadInfo;

   public SignoffData() {
       data = new Hashtable();
       }

   public SignoffData(String uploadInfo, String dataString) {
       this.uploadInfo = uploadInfo;
       String[] lines = dataString.split("[\\n\\r]");
       String keyword="None";
       data = new Hashtable();
       for(int line=0;line<lines.length;line++) {
           if(lines[line].startsWith("#")) continue;
           if(lines[line].startsWith("%")) {
             keyword=lines[line];
             continue;
             }
           if(data.containsKey(keyword)) {
               String oldData = (String)data.get(keyword);
               oldData += "\n"+lines[line];
               data.put(keyword,oldData);
               }
           else data.put(keyword,lines[line]);
           }
        }

   public String getString(int index) {
       if(!data.containsKey(keywords[index])) return null;
       return (String)data.get(keywords[index]);
       }
   public void put(String key, String value) {
       data.put(key,value);
       }
   public String getUploaderInfo() {
       return uploadInfo;
       }
    public Vector allFieldsPresent(int uploadType) {
        Vector listOfMissingFields = new Vector();
        for(int i=0;i<keywords.length;i++) {
           if(compulsoryFields[uploadType][i] && !data.containsKey(keywords[i])) listOfMissingFields.add(descriptions[i]);
           }
        // if barrelcategory is '56', then require a reason
        if(data.containsKey(keywords[BARREL])) {
           if(((String)data.get(keywords[BARREL])).equals("56") && !data.containsKey(keywords[B56REASON])) listOfMissingFields.add(descriptions[B56REASON]);
           }
        // if category is 'FAIL' then require a reason
        if(data.containsKey(keywords[CATEGORY])) {
           if(((String)data.get(keywords[CATEGORY])).equals("FAIL") && !data.containsKey(keywords[FAILREASON])) listOfMissingFields.add(descriptions[FAILREASON]);
           }
        return listOfMissingFields;
        }
    public String writeUploadDataFile(String sn) throws Exception {
        File outFile = new File(PreferencesInterface.getInstance().getPreference(PreferencesInterface.UPLOAD_DIR),sn+"_signoffdata.txt");
        BufferedWriter out = new BufferedWriter(new FileWriter(outFile));
        for(int i=0;i<keywords.length;i++) {
            if(!data.containsKey(keywords[i])) continue;
            out.write(keywords[i]);
            out.newLine();
            out.write((String)data.get(keywords[i]));
            out.newLine();
            }
         out.close();
         return outFile.getAbsolutePath();
         }

}